#include "dvbrecorder.h"
#include <vdr/channels.h>
#include <vdr/config.h>
#include <vdr/device.h>
#include <vdr/skins.h>

cTSRecorder::cTSRecorder(cDevice* Device, cChannel const* Channel, int Priority)
    : receiver(Channel, Priority)
{
    
}

cTSRecorder* cTSRecordControls::recordControl = NULL;

bool cTSRecordControls::Start()
{
    int ch = cDevice::CurrentChannel();
    cChannel const* channel = Channels.GetByNumber(cDevice::CurrentChannel());
    if (channel == NULL) {
        esyslog("ERROR: channel %d not defined", ch);
        return false;
    }

    int priority = Setup.PausePriority;
    cDevice* device = cDevice::GetDevice(channel, priority, false);
    if (device == NULL) {
        Skins.Message(mtError, "No free DVB device to record!");
        isyslog("no free DVB device to record channel %d", ch);
        return false;
    }

    dsyslog("switching device %d to channel %d", device->DeviceNumber() + 1, channel->Number());
    if (!device->SwitchChannel(channel, false)) {
        Skins.Message(mtError, "Couldn't switch device!");
        esyslog("ERROR: couldn't switch device %d to channel %d", device->DeviceNumber() + 1, channel->Number());
        return false;
    }

    if (recordControl != NULL) {
        Skins.Message(mtError, "Already recording!");
        isyslog("already recording a dvbchain");
        return false;
    }

    recordControl = new cTSRecorder(device, channel, priority);
    return true;
}
