#include <vdr/device.h>
#include "dvbsink.h"
#include "tstools.h"

// --- cESVideoIndexer -------------------------------------------------------

void cESVideoIndexer::ReceivePackets(uchar const* Data, int Length)
{
    uchar const* end = Data + Length;
    for (uchar const* p = Data; p < end; ++p) {
        //std::cout.write(reinterpret_cast<char const*>(p), 1);
        switch (found) {
        case 0: // 0x00
            packetStart = PacketInfos().PacketOffset;
        case 1: // 0x00
            if (*p == 0x00) ++found;
            else found = 0;
            break;

        case 2: // 0x01
            if (*p == 0x01) ++found;
            else if (*p != 0x00) found = 0;
            break;

        case 3:
            switch (*p) {
            case SC_PICTURE:
            case SC_GROUP:
                if (pictureStart == InvalidOffset) break;
            case SC_SEQUENCE:
                if (pictureStart == InvalidOffset) pictureStart = packetStart;
                if (lastStartCode >= 0x01 && lastStartCode <= 0xaf) {
                    indexFile.Write(pictureType, 0, pictureStart);
                    //isyslog("Found video packet at %u: 00 00 01 %02x pictureType=%d", pictureStart, *p, pictureType);
                    pictureStart = packetStart;
                }
            case 0x01 ... 0xaf: // slice start codes
                lastStartCode = *p;
                break;
            }

            if (*p == SC_PICTURE) ++found;
            else found = 0;
            break;

        case 4:
            ++found;
            break;

        case 5:
            pictureType = (*p & COD_TYPE_MASK) >> 3;
            found = 0;
            break;
        }
    }
}
