#define TEST_DVBCHAIN
#include <fstream>
#include <iostream>
#include <istream>
#include <sstream>
#include <string>
#include <unistd.h>
#include "dvbfilter.h"
#include "dvbsink.h"
#include "dvbsource.h"
#include <vdr/videodir.h>

#include "../../../recorder.c"

using namespace std;

template< class To, class From >
To lexical_cast( From const& from )
{
	stringstream s;
	s << from;
	To to;
	s >> to;
	return to;
}
#if 1
int main(int argc, char* argv[]) 
{
    if (argc < 3) {
        cerr << "Usage: " << argv[0] << " <vpid> <apids...>" << endl;
        return 1;
    }

    int vpid = lexical_cast<int>(argv[1]);
    int apids[] = { lexical_cast<int>(argv[2]), 0 };

    string fileName = string(VideoDirectory) + "/PES";

    cRemux remux(vpid, 0, apids, 0, true);
    cFileWriter writer(fileName.c_str(), &remux);
    writer.Start();

    uchar buffer[TS_SIZE*1000];
    int length = 0;
    int r = 0;

    r = read(STDIN_FILENO, buffer + length, sizeof(buffer) - length);
    if (r <= 0)
        return 1;
    length += r;
    
    do {
        int count = remux.Put(buffer, length);
        if (count) {
            length -= count;
            memmove(buffer, buffer + count, length);
        } else
            usleep(1000);
        
        if (length < sizeof(buffer)) {
            r = read(STDIN_FILENO, buffer + length, sizeof(buffer) - length);
            if (r <= 0)
                break;
            length += r;
        }
    } while (length > 0);

    cout << "fertig r = " << r << ", length = " << length << endl;
    sleep(1000);
}

#else
int main( int argc, char* argv[] )
{
	if ( argc < 3 ) {
		cerr << "Usage: " << argv[0] << " <vpid> <recdir>" << endl;
		return 1;
	}

	int pids[] = { lexical_cast< int >( argv[1] ) };

    string filename = string( argv[2] ) + "/index.vdr";
    if ( access( filename.c_str(), R_OK ) != -1 ) {
        cerr << "Index file already present, won't delete" << endl;
        return 1;
    }

    filename = string( argv[2] ) + "/001.ts.vdr";
    if ( access( filename.c_str(), R_OK ) == -1 ) {
        cerr << "Couldn't find ???.ts.vdr" << endl;
        return 1;
    }

    ifstream in( filename.c_str(), ios::in | ios::binary );
    if ( !in ) {
        cerr << "Couldn't open ???.ts.vdr" << endl;
        return 1;
    }

	// Construct (virtual) chain
    cFileSource<stDvbTS> source( filename.c_str() );
    cTSPacketScanner scanner;
    //cTSPayloadExtractor extractor( pids[0] );
    //cESVideoIndexer indexer("ZDF");

    source.Connect( &scanner );//.Connect( &extractor ).Connect( &indexer );

    source.Start();
    source.WaitForEnd();
}
#endif
